# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "conf/ac-conf.rb"

require 'rubygems'
require "date"
require_gem 'activerecord'

require LIBRARY_DIR + "/common.rb"
require LIBRARY_DIR + "/injector.rb"
require LIBRARY_DIR + "/webapp.rb"
require APP_ROOT + '/models/user.rb'
require APP_ROOT + '/models/user_setting'

ENV['PATH'] = '/bin'

def run(app) # for backward compatibility 
  app.run()
end

def current_month()
  year, mon = []
  File.open(CURRENT_MONTH) {|fp|
    fp.flock(File::LOCK_SH)
    year, mon = fp.gets.gsub(/[\r\n]/, '').split("/")
  }
  s = <<EOF
<input type="hidden" name="current-year" value="#{year}">
<input type="hidden" name="current-month" value="#{mon}">
<p>#{year}年#{mon}月度
EOF
  return s
end

# 翌月（歴月）の初日を表すDateインスタンス
def next_month(date)
  r = date + 1
  while r.mon == date.mon
    r += 1
  end
  return r
end


def format_date(d)
  sprintf("%04d.%02d.%02d", d.year, d.mon, d.day)
end

def format_date_long(d)
  sprintf("%04d年%2d月%2d日", d.year, d.mon, d.day)
end
