#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "pcview.rb"
require APP_ROOT + '/models/budget_detail'
require APP_ROOT + '/models/account_title'

class Form < PCView
  def budget_form(user, begin_date, end_date)
    budgets = Budget.find(:all,
                      :include => 'budget_details',
                      :conditions => ['user_id = ? and date between ? and ?', 
                                      user.id, begin_date, end_date],
                      :order => 'date')

    model = {
      :period => "#{begin_date} 〜 #{end_date}",
      :bday => begin_date.to_s,
      :eday => end_date.to_s,
      :columns => budgets.size + 1,  # +1は新しい列
      :days => [],
      :group => []
    }

    # タイトル行
    budgets.each_with_index {|b, i|
      model[:days] << {
        :idn => "id#{i}",
        :idv => b.id,
        :sel_date => get_sel_date(i.to_s, b.date.year, b.date.mon, b.date.day)
      }
    }
    model[:days] << {
      :sel_date => get_sel_date(budgets.size.to_s, 
                                begin_date.year, begin_date.mon, begin_date.day)
    }

    # 勘定科目  activeでない科目も金額が設定されていれば表示する。
    ac_titles = AccountTitle.find_by_sql([<<EOF, user.id, user.id, begin_date, end_date])
(SELECT * FROM account_titles
  WHERE user_id = ? AND (ac_type = 4 or ac_type = 5) AND active <> 0)
UNION 
(SELECT account_titles.*
  FROM budgets JOIN budget_details ON budgets.id = budget_details.budget_id
       JOIN account_titles ON budget_details.account_title_id = account_titles.id
  WHERE budgets.user_id = ? and (budgets.date between ? and ?))
ORDER BY ac_type, sort
EOF
    
    gr = nil
    ac_titles.each_with_index {|item, i|
      if !gr || item.ac_type != gr[:ac_type] 
        gr = {
          :ac_type => item.ac_type,
          :grname => AccountTitle::ACTYPE_NAMES[item.ac_type],
          :list => []
        }
        model[:group] << gr
      end

      line = {
        :acname => item.name,
        :acn => "ac#{i}",
        :acv => item.id,
        :amounts => []
      }
      gr[:list] << line

      budgets.each_with_index {|b, j|
        d = b.budget_details.find(:first, 
                                  :conditions => ['account_title_id = ?', item.id])
        if d
          line[:amounts] << {:an => "am#{i}_#{j}", :av => d.amount}
        else
          line[:amounts] << {:an => "am#{i}_#{j}"}
        end
      }
      line[:amounts] << {:an => "am#{i}_#{budgets.size}"}
    }
    model[:lines] = ac_titles.size

    page_out("budget_edit.html", model)
  end

  def main
    if cgi["byear"].first
      begin_date = Date.new(cgi["byear"].first.to_i, cgi["bmon"].first.to_i,
                            cgi["bday"].first.to_i)
      end_date = Date.new(cgi["eyear"].first.to_i, cgi["emon"].first.to_i,
                          cgi["eday"].first.to_i)
    else
      begin_date = Date.parse(cgi["bdate"].first)
      end_date = Date.parse(cgi["edate"].first)
    end

    budget_form(user, begin_date, end_date)
  end
end

run(Form.new)
