#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "pcview.rb"
require APP_ROOT + '/models/budget_detail'
require APP_ROOT + '/models/account_title'

class Form < PCView
  def get_day(y, m, d)
    if !@bday
      @bday = Date.parse(cgi.get("bday"))
      @eday = Date.parse(cgi.get("eday"))
    end

    raise if !Date.exist?(y, m, d)
    day = Date.new(y, m, d)
    raise if day < @bday || day > @eday # TODO:fixme
    return day
  end

  def set_budget(cgi, user)
    columns = cgi.get('columns').to_i
    lines = cgi.get('lines').to_i
    raise if columns == 0
    raise if lines == 0

    Budget.transaction {
      (0..columns-1).each {|col|
        bid = cgi.get("id#{col}", nil)
        y = cgi.get("#{col}year").to_i
        m = cgi.get("#{col}mon").to_i
        d = cgi.get("#{col}day").to_i

        # 日付が空白のときは、その列を削除。
        if bid
          budget = Budget.find(bid, :conditions => ['user_id = ?', user.id]) 
          if y == 0 && m == 0 && d == 0
            Budget.delete budget.id
            next
          end
          budget.date = get_day(y, m, d)
        else
          next if y == 0 && m == 0 && d == 0
          budget = Budget.new(:user => user, :date => get_day(y, m, d), :comment => "")
        end

        (0..lines-1).each {|i|
          ac = AccountTitle.find_item(cgi.get("ac#{i}"), user)
          amount = cgi.get("am#{i}_#{col}").to_i
          detail = budget.budget_details.find(:first, 
                                              :conditions => ['account_title_id = ?', 
                                                              ac.id])
          if detail
            if amount != 0
              detail.amount = amount
            else
              budget.budget_details.delete detail
            end
          else
            if amount != 0
              budget.budget_details << BudgetDetail.new(:account_title => ac, 
                                                        :amount => amount)
            end
          end
        }
        
        if budget.budget_details.size == 0
          Budget.delete(budget.id) 
        else
          budget.save!
        end
      }
    } # of transaction
  end

  def main
    set_budget(cgi, user)
    header_out(cgi, "予算（目標）設定")
    print <<EOF
<p>予算を設定しました。
EOF
    footer_out(cgi)
  end
end

run(Form.new)
