#!/home/netsphere/bin/ruby

# Q's Account Book
# Copyright (c) 2002 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# 携帯用受付画面

require "conf/ac-conf.rb"

require LIBRARY_DIR + "/common.rb"
require LIBRARY_DIR + "/cgisup.rb"
require "nkf"

require "ac-items.rb"
require "jskyview.rb"

$SAFE = 1

class Form < JSkyView
  def result_out(user, ary)
    ac_titles = AcTitleStore.get(user)

    html = <<EOF
Content-Type: text/html; charset=Shift_JIS

<html>
<head>
  <title>送信結果</title>
</head>
<body>
<h1>送信結果</h1>

<table border="1">
<tr><th>借方</th><th>貸方</th><th>金額</th>
EOF
  total = 0
  ary.each {|r|
    html += "<tr><td>" + ac_titles.find_by_code(r.dr_code).name_short + "</td>"
    html += "<td>" + ac_titles.find_by_code(r.cr_code).name_short + "</td>"
    html += "<td align=\"right\">#{decimal_format(r.amount)}</td>\n"
    total += r.amount
  }
  html += <<EOF
</table>
計:#{decimal_format(total)}
<p><a href="j.rb">さらに出金を登録する</a>
</body>
</html>
EOF
    print e2s(html)
  end

  def post(cgi, user)
    now = Time.now
    lines = cgi["lines"].first.to_i
    cr_code = cgi["t"].first.to_i
    mon = cgi.get("m").to_i; day = cgi.get("d").to_i
    ary = Array.new
    File.open(FilePath.tmp_journal(user), "a") {|fp|
      fp.flock(File::LOCK_EX)
      (1 .. lines).each {|i|
        code = cgi["k-#{i}"].first.to_i
        amount = cgi["v-#{i}"].first.to_i
        remarks = cgi["r-#{i}"].first
        comment = cgi["c-#{i}"].first
        if amount != 0
          r = MobTempDisbursement.new(now, code, cr_code, amount, s2e(remarks),
                                      s2e(comment), mon, day)
          ary << r
          fp.print r.to_s, "\n"
        end
      }
    }
    return ary
  end

  def main
    case cgi['a'].first
    when 'p'
      ary = post(cgi, user)
      result_out(user, ary)
    else
      print "Content-Type: text/html\n\n"
      print "<p>action error.\n"
    end
  end
end

run(Form.new)
