#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# 仕訳帳

require "pcview.rb"
require APP_ROOT + '/models/invoice.rb'
require APP_ROOT + '/models/payment_amount.rb'


class ViewJournal < Wafu::Action
  def execute(af)
    fixed = @app.user.user_setting.fixed_date
    op_date = @app.user.user_setting.opening_date

    begin_date = af.begin_date
    end_date = af.end_date
    begin_date = op_date + 1 if begin_date <= op_date
    end_date = op_date + 1 if end_date <= op_date

    ary = JournalEntry.find(:all, 
                            :conditions => ['user_id = ? and date between ? and ?',
                                            @app.user.id, begin_date, end_date],
                            :order => 'date, entry_no, id')
    
    new_begin, new_end = UserSetting.get_ac_month(@app.user)
    new_end = [new_end, Date.today].max
    
    # 表示
    model = {
      :begin_date => format_date_long(begin_date),
      :end_date => format_date_long(end_date),
      :journal => [],
      :byear => new_begin.year.to_s,
      :bmon => new_begin.mon.to_s,
      :bday => new_begin.day.to_s,
      :eyear => new_end.year.to_s,
      :emon => new_end.mon.to_s,
      :eday => new_end.day.to_s
    }

    prev = nil
    ary.each_with_index {|r, idx|
      if same_entry?(prev, r)
        line = {
          :date => "",
          :num => "",
          :if_cur => nil
        }
      else
        line = {
          :date => format_date(r.date),
          :num => r.entry_no,
          :if_cur => r.invoice.nil? ? 
            (r.date > fixed && r.payment_amount.nil? ? {
              :edit => "journal-edit.rb?action=edit&amp;seq=#{r.id}"} : nil) :
            {:edit => "purchase-edit.rb?id=#{r.invoice.id}"}
        }
      end
      line.update({
        :dr_name => AccountTitle.find_item(r.dr_code, @app.user).name,
        :cr_name => AccountTitle.find_item(r.cr_code, @app.user).name,
        :amount => decimal_format(r.amount),
        :remarks => r.remarks.to_s,
        :comment => r.comment.to_s,
      })
      model[:journal] << line
      prev = r
    }

    @app.page_out("jour-view.html", model)
  end
end

class RangeReload < Wafu::Action
  def execute(af)
    model = {
      :byear => af.by,
      :bmon => af.bm,
      :bday => af.bd,
      :eyear => af.ey,
      :emon => af.em,
      :eday => af.ed
    }
    if af.error?
      model[:error] = af.errors
    end
    @app.page_out("jour.html", model)
  end
end

class Form < PCView
  def main()
    actions = {
      "*" => [DateRangeActionForm, ViewJournal, RangeReload]
    }
    dispatch(actions)
  end
end

Form.new.run
