# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "conf/ac-conf.rb"

require "date"
require LIBRARY_DIR + "/cgisup.rb"
require LIBRARY_DIR + "/datesup.rb"
require LIBRARY_DIR + "/strstore.rb"
require APP_ROOT + '/models/journal_entry.rb'

class Account
  def initialize(user)
    @op_date = user.user_setting.opening_date
    @user = user
  end

  # 各日付までのB/S，P/Lを求める。最初の日付分は，B/Sのみ。
  # 入力
  #   ary    日付の配列。
  def get_fs_multi(day_ary)
    raise TypeError if !day_ary.is_a?(Array)
    raise ArgumentError if day_ary.size < 2

    records = JournalEntry.find(:all, 
                                :conditions => ['user_id = ? and date <= ?',
                                                @user.id, day_ary.last],
                                :order => 'date')

    result = []
    ridx = 0
    day_ary.each {|d|
      raise TypeError if !d.is_a?(Date)

      fs = {}
      if result.size > 0
        result.last.each {|k, v|
          fs[k] = v if AccountTitle.find_item(k, @user).bs?
        }
      end

      while ridx < records.size && records[ridx].date <= d
        r = records[ridx]
        fs[r.dr_code] = (fs[r.dr_code] || 0) + r.amount
        fs[r.cr_code] = (fs[r.cr_code] || 0) - r.amount
        ridx += 1
      end
      result << fs
    }

    return result
  end
end
