
# Q's Account Book
# Copyright (c) 2002 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "ac-common.rb"

class JSkyView < Wafu::WebApp
  def initialize(opt_hash = {})
    opt = {
      "session_type" => "auth_required",
      "session_option" => {
        "tmpdir" => SESSION_DIR, "holdtime" => SESSION_HOLD_TIME,
        "store_in_cookie" => "no"
      },
      "pwdfile" => FilePath.passwd
    }
    opt.update(opt_hash)
    super(opt)
  end

  def internal_error_message_out()
    print <<EOF
Content-Type:text/html; charset=EUC-JP

<html>
<head>
  <title>内部エラー発生</title>
</head>
<body>
</table></ul></dl>
<h1>内部エラー発生</h1>
<p>予期しないエラーが発生しました。ご迷惑をお掛けします。
EOF
  end

  def login_form(mes)
    s = <<EOF
Content-Type: text/html; charset=Shift_JIS

<html>
<head>
  <title>ログイン</title>
</head>
<body>
<h1>ログイン</h1>
EOF
    if mes == Wafu::LOGON_RETRY
      s += "ユーザーIDまたはパスワードが違います。\n"
    elsif mes == Wafu::LOGON_EXPIRE
      s += "セッション維持時間を越えました。再ログインが必要です。\n"
    end
    s += <<EOF
<form method="get" action="./j.rb">
ユーザーID:<input type="text" size="4" mode="alphabet" name="user"><br>
パスワード:<input type="text" size="4" mode="alphabet" name="pwd"><br>
<input type="submit" value="ログイン">
</form>
</body>
</html>
EOF
    print e2s(s)
  end

  def footer_out()
    print <<EOF
</body>
</html>
EOF
  end
end
