#!/home/netsphere/bin/ruby
# -*- mode:ruby; coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2005 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "pcview.rb"
require "closing-common.rb"
require "pl2.rb"
require APP_ROOT + '/models/user_setting'

class WelcomeForm < Wafu::Action
  def execute(af)
    model = {
      :long_name => @app.user.name,
      :mod_form => Amrita::SanitizedString[set_closing_day_form(@app.user)]
    }
    @app.page_out("welcome1.html", model)
  end
end

class Tmp2PermForm < Wafu::Action
  attr_accessor :slip_ary
  
  def execute(af)
    ac_chooser = AcChooser.new(@app.user)

    @app.header_out(@app.cgi, "振替伝票")
    print <<EOF
<p>携帯電話で入力した伝票があります。不要な行は、金額欄を空白にしてください。
<form method="post" action="./tmp2perm2.rb">
<table class="tbl">
<tr><th colspan="2">日付<th rowspan="2">借方科目<th rowspan="2">貸方科目
  <th rowspan="2">金額<th colspan="2">摘要
<tr><th>月<th>日<th>相手<th>内容
EOF
    lines = 1
    @slip_ary.each {|r|
      day = get_full_day(r.mon, r.day, Date.today)
      print "<tr>"
      print '<td><input type="text" class="num" size="3" name="mon-', lines, '" value="',
            day.mon, '">'
      print '<td><input type="text" class="num" size="3" name="day-', lines, '" value="',
            day.day, '">'
      print "<td>", ac_chooser.get_sel_acitems("drcode-#{lines}", r.dr_code)
      print "<td>", ac_chooser.get_sel_acitems("crcode-#{lines}", r.cr_code)
      print <<EOF
<td><input type="text" size="12" class="num" name="amount-#{lines}" value="#{r.amount}">
<td><input type="text" size="15" name="remarks-#{lines}" value="#{r.remarks}">
<td><input type="text" size="25" name="comment-#{lines}" value="#{r.comment}">
EOF
      lines += 1
    }
    print <<EOF
</table>
<input type="submit" value="確定">
<input type="hidden" name="lines" value="#{lines}">
EOF
    @app.footer_out()
  end
end

class MenuForm < Wafu::Action
  def execute(af)
    begin_date = nil; end_date = nil
    begin_date, end_date = UserSetting.get_ac_month(@app.user)
    end_date = [end_date, Date.today].max

    fs = FSTemplate.new(@app.user, begin_date, end_date)

    model = {
      :username => CGI.escapeHTML(@app.user.name),
      :pl_mod => Amrita::SanitizedString[fs.pl()],
      :notice => @app.get_flash("notice")
    }
    @app.page_out("menu.html", model)
  end
end

class Form < PCView
  def main()
    raise ArgumentError, "user invalid: '#{user}'" if user == ""

    setting_finished = user.user_setting && 
      user.user_setting.opening_date ? true : false

    if !setting_finished
      # 初めてのアクセス
      action = WelcomeForm.new(self)
      action.execute(nil)
    else
      ary = Array.new
=begin
      if FileTest.exist?(FilePath.tmp_journal(user))
        File.open(FilePath.tmp_journal(user), "r") {|fp|
          fp.flock(File::LOCK_SH)
          while line = fp.gets
            r = MobTempDisbursement.parse(line.gsub(/[\r\n]/, ''))
            ary << r
          end
        }
      end

      if ary.size > 0
        # 携帯電話で入力した伝票があるとき
        action = Tmp2PermForm.new(self)
        action.slip_ary = ary
        action.execute(nil)
      else
=end
        action = MenuForm.new(self)
        action.execute(nil)
    #  end
    end
  end
end

run(Form.new)
