# -*- coding:utf-8 -*-

require "./banner.rb"
require LIBRARY_DIR + "/cgisup.rb"

SITE_MAP = {
  "index.rhtml" => {:title => "トップ"},
  "tour.rhtml" => {:title => "機能ツアー"},
  "history.rhtml" => {:title => "更新履歴"},
}

class Navigation
  def initialize(key_)
    @key = key_
  end

  def title()
    return "シンプルWeb家計簿: #{SITE_MAP[@key][:title]}"
  end

  def head_content()
    return <<EOF
  <meta http-equiv="Content-Language" content="ja">
  <meta http-equiv="Content-Script-Type" content="text/javascript">
  <meta http-equiv="Content-Style-Type" content="text/css">
  <link rel="stylesheet" href="./tour.css" type="text/css">
  <link rel="start" href="http://www.nslabs.jp/">
  <link rel="copyright" href="./copyright.rhtml">
  <link rev="made" href="mailto:vzw00011@nifty.ne.jp">
  <title>#{title()}</title>
  <base target="_top">
EOF
  end

  def link_to(to_key)
    if @key == to_key 
      SITE_MAP[to_key][:title]
    else
      "<a href=\"#{to_key}\">#{SITE_MAP[to_key][:title]}</a>"
    end
  end

  def top_menu()
    return <<EOF
<h1>シンプルWeb家計簿</h1>
<div id="topmenu">
<ul>
  <li>#{link_to "index.rhtml"}
  <li>#{link_to "tour.rhtml"}
  <li>#{link_to "history.rhtml"}
</ul>
</div>
EOF
  end

  def bottom()
    b = Banner.new 
    return b.banner_body(@key, nil) << <<EOF
<hr>
<div align="right">
シンプルWeb家計簿 http://www.nslabs.jp/ac/<br>
Copyright (c) HORIKAWA Hisashi. All rights reserved.
</div>
EOF
  end
end
