#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# 取引先（支払先）の登録・編集

require "pcview.rb"
require APP_ROOT + '/models/partner'
require APP_ROOT + '/models/account_title'

class EditForm < Wafu::Action
  def get_sel_payable_items(name, default)
    ac = AccountTitle.find(:all, 
                     :conditions => ['user_id = ? and active <> 0 and ac_type = 2', 
                                     @app.user.id],
                     :order => 'sort')
    return get_sel_acitems_sub(ac, name, default)
  end

  def execute(af)
    partners = Partner.find(:all, :conditions => ['user_id = ?', @app.user.id])
    lines = partners.size + 3
    model = {
      :lines => lines,
      :ac_sel => get_sel_payable_items("ac_sel", 
                                       @app.user.user_setting.payable_item),
      :list => []
    }
    (0..lines-1).each {|i|
      line = {
        :name => "name#{i+1}",
        :desc => "desc#{i+1}" }
      if partners[i]
        line[:nv] = partners[i].name
        line[:dv] = partners[i].description
        line[:codetag] = {:code => "code#{i+1}", :cv => partners[i].id}
      end
      model[:list] << line 
      } 
    @app.page_out('partner_listedit.html', model)
  end
end

class DoneAF < Wafu::ActionForm
  attr_reader :data, :lines, :payable_item
  def validate
    err = []
    @payable_item = @app.cgi.get("ac_sel").to_i
    err << "内部エラー: 未払金科目が不正" if @payable_item == 0

    @lines = @app.cgi["lines"].first.to_i
    err << "内部エラー: フォームデータが不正" if @lines == 0
    @data = []
    (1..lines).each {|i|
      @data << [@app.cgi.get("code#{i}").to_i, @app.cgi.get("name#{i}").strip, 
                @app.cgi.get("desc#{i}").strip ]
    }
    return set_error(err) 
  end
end

class DoneForm < Wafu::Action
  def execute(af)
    Partner.transaction {
      @app.user.user_setting.payable_item = af.payable_item
      @app.user.user_setting.save!

      (0..af.lines-1).each {|i|
        if af.data[i][1] && af.data[i][1] != "" 
          # 更新・追加
          if af.data[i][0] == 0
            partner = Partner.new(:user => @app.user,
                                  :name => af.data[i][1], 
                                  :description => af.data[i][2])
          else
            partner = Partner.find(af.data[i][0], 
                                   :conditions => ['user_id = ?', @app.user.id])
            partner.name = af.data[i][1]
            partner.description = af.data[i][2]
          end
          partner.save!
        else
          # 削除
          if af.data[i][0] != 0
            Partner.delete(af.data[i][0])
          end
        end
      }  
    }
    @app.page_out("partner_listedit_done.html", {})
  end
end

class EditApp < PCView
  def main
    actions = {
      '*' => [nil, EditForm, nil],
      'determine' => [DoneAF, DoneForm, EditForm]
    }
    dispatch(actions)
  end
end

EditApp.new.run()
