#!/home/netsphere/bin/ruby
# -*- mode:ruby; coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2005 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "pcview.rb"

class FirstCheck < Wafu::ActionForm
  def validate 
    err = []
    err << "guestユーザはパスワードを変更できません。" if @app.user == "guest"
    return set_error(err)
  end
end

class ErrorPage < Wafu::Action
  def execute(af)
    # TODO: fixme
  end
end

class PasswordSetting < Wafu::Action
  def execute(af)
    model = {}
    if af.error?
      model[:error] = {:list => af.errors}
    end
    @app.page_out("setting-password1.html", model)
  end
end

class PasswordCheckAF < Wafu::ActionForm
  attr_reader :new_pwd
  def validate()
    @new_pwd = @app.cgi.get("new")
    new_pwd2 = @app.cgi.get("new2")
    
    err = []
    if @app.user == "guest"
      err << "ゲストユーザは変更できません。"
    end
    if @new_pwd == ""
      err << "パスワードがありません。"
    end
    if @new_pwd != new_pwd2
      err << "1行目と2行目のパスワードが違います。"
    end
    return set_error(err)
  end
end

class PasswordSettingDone < Wafu::Action
  def execute(af)
    @app.user.set_password(af.new_pwd)
    @app.user.save!

    # 表示
    @app.page_out("setting-password2.html", {})
  end
end

class FormApp < PCView
  def main()
    actions = {
      "*" => [FirstCheck, PasswordSetting, ErrorPage],
      "do" => [PasswordCheckAF, PasswordSettingDone, PasswordSetting]
    }
    dispatch(actions)
  end
end

FormApp.new.run()
