#!/home/netsphere/bin/ruby
# -*- mode:ruby; coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2005 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# プロフィールの変更

require "pcview.rb"

class FirstCheck < Wafu::ActionForm
  def setup
    @realname = @app.user.name
    @mail = @app.user.email
  end
  attr_reader :realname, :mail
end

class ProfileSetting < Wafu::Action
  def execute(af)
    model = {
      :realname => af.realname,
      :mail => af.mail
    }
    if af.error?
      model[:error] = {:list => af.errors}
    end
    @app.page_out("setting-profile1.html", model)
  end
end


class UpdateAF < Wafu::ActionForm
  attr_reader :realname, :mail

  def setup()
    @realname = @app.cgi.get("realname")
    @mail = @app.cgi.get("mail")
  end

  def validate()
    err = []
    if @app.user == "guest"
      err << "ゲストユーザは変更できません。"
    end
    if !@mail || @mail == "" || !valid_mail_addr(@mail)
      err << "メールアドレスが正しくありません。"
    end
    return set_error(err)
  end
end

class ProfileSettingDone < Wafu::Action
  def execute(af)
    @app.user.name = af.realname
    @app.user.email = af.mail
    @app.user.save!

    # 表示
    @app.page_out("setting-profile2.html", {})
  end
end


class FormApp < PCView
  def main()
    actions = {
      "*" => [FirstCheck, ProfileSetting, nil],
      "update" => [UpdateAF, ProfileSettingDone, ProfileSetting]
    }
    dispatch(actions)
  end
end

FormApp.new.run()

