#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "pcview.rb"
require APP_ROOT + '/models/account_title'

class Form < PCView
  def main
    ac_titles = AccountTitle.find(:all, :conditions => ['user_id = ?', user.id],
                                  :order => 'ac_type, sort')

    model = {
      :group => [],
      :notice => get_flash("notice")
    }

    gr = nil
    ac_titles.each {|item|
      if !gr || item.ac_type != gr[:ac_type]
        gr = {
          :grname => AccountTitle::ACTYPE_NAMES[item.ac_type],
          :aclist => [],
          :ac_type => item.ac_type
        }
        model[:group] << gr
      end

      gr[:aclist] << {
        :sort => item.sort,
        :name => item.name,
        :mobname => item.name_short,
        :cf_type => AccountTitle::CFTYPE_NAMES[item.cf_type],
        :desc => item.description,
        :inactive => item.active != 0 ? '' : 'inactive',
        :edit_link => "titles-edit.rb?ac=#{item.id}"
      }
    }

    page_out("titles-list.html", model)
  end
end

run(Form.new)
