#!/home/netsphere/bin/ruby
# -*- encoding:euc-jp -*-

# Q's Account Book
# Copyright (c) 2002 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "pcview.rb"
require "ac-items.rb"
require "journal-common.rb"

$SAFE = 1

class MyActionForm < Wafu::ActionForm
  def validate()
    error_ary = []
    period = nil
    @app.db.transaction_ro {|db|
      period = db.get_addable_period(@app.user)
    }

    lines = @app.cgi["lines"].first.to_i
    ary = Array.new
    (1..lines).each {|i|
      r = JournalRecord.new
      r.dr_code = @app.cgi["drcode-#{i}"].first.to_i
      r.cr_code = @app.cgi["crcode-#{i}"].first.to_i
      r.amount = @app.cgi["amount-#{i}"].first.to_i
      if r.dr_code != 0 && r.cr_code != 0 && r.amount != 0
        # 日付
        ms = @app.cgi["mon-#{i}"].first.to_i
        ds = @app.cgi["day-#{i}"].first.to_i
        r.date = Date.new(period[0].year, ms, ds)
        r.date = Date.new(period[1].year, ms, ds) if r.date < period[0]
        if r.date < period[0] || r.date > period[1]
          error_ary << "登録可能期間の外の日付です。"
          next
        end

        # 摘要
        r.remarks = @app.cgi["remarks-#{i}"].first.strip
        r.comment = @app.cgi["comment-#{i}"].first.strip
        r.seq = incr_counter(FilePath.seq_counter(@app.user))
        r.num = incr_counter(FilePath.journal_counter(@app.user))
        ary << r
      end
    }

    @journal_data = ary
    return set_error(error_ary)
  end
  attr_reader :journal_data
end

class Form < PCView
  def main
    af = MyActionForm.new(self)
    af.validate()
    if af.error?
      do_error
    end

    ok = nil; error = nil
    JournalStore.new(user, db).transaction {|store|
      ok, error = store.append(af.journal_data)
    }
    File.unlink(FilePath.tmp_journal(user))
    journal_add_result_out(self, ok, error)
  end
end

run(Form.new)

