
require "./ac-common.rb"
require "./ac-items.rb"

# 開始残高0を削除する
def fix_opdb(user)
  StrStore.new(FilePath.opening_balance(user)).transaction {|opdb|
    opdb.keys.each {|codestr|
      if opdb[codestr].to_i == 0
        opdb.delete(codestr)
      end
    }
  }
end

# 不正な勘定科目を削除する
def fix_ac_titles(user)
  new_ary = []
  AcTitleStore.get(user).each {|item|
    if item.code.to_i != 0
      new_ary << item
    end
  }
  AcTitleStore.store(user, new_ary)
end

def check_prof(user)
  StrStore.new(FilePath.profile(user)).transaction_ro {|profdb|
    print "#{user}: no fixed\n" if !profdb.key?("fixed")
    print "#{user}: no unappro...\n" if !profdb.key?("unappropriated-item")
  }
end

# 開始残高および仕訳 <-> 勘定科目 の整合性
def main
  users = nil
  StrStore.new(FilePath.passwd).transaction_ro {|pwddb| users = pwddb.keys}

  users.each {|user|
    if !FileTest.exist?(PRIVATE_DIR + "/" + user)
      print "#{user}: dir not found.\n"
    else
      check_prof(user)

      # fix_opdb(user)
      # fix_ac_titles(user)

      # 勘定科目
      ac_titles = AcTitleStore.get(user)
      ac_titles.each {|item|
        if item.code.to_i == 0
          print "#{user}: item error: #{item}\n"
        end
      }

      # 初期残高
      StrStore.new(FilePath.opening_balance(user)).transaction_ro {|opdb|
        opdb.keys.each {|op_key|
          if opdb[op_key].to_i == 0
            print "#{user}: op value zero: key = #{op_key}\n"
          end
          if !ac_titles.find_by_code(op_key.to_i)
            print "#{user}: op #{op_key}\n"
          end
        }
      }

      # 仕訳
      have_error = false
      store = JournalStore.new(user, db).transaction_ro {|store|
        store.each {|r|
          if !ac_titles.find_by_code(r.dr_code)
            print "#{user}: jo #{r.dr_code}\n"
            have_error = true
            ac_titles << AcTitle.new(r.dr_code, r.dr_code.to_s, "", 2, 1, "")
          end
          if !ac_titles.find_by_code(r.cr_code)
            print "#{user}: jo #{r.cr_code}\n"
            have_error = true
            ac_titles << AcTitle.new(r.cr_code, r.cr_code.to_s, "", 2, 1, "")
          end
        }
      }

      # 剰余金科目
      StrStore.new(FilePath.profile(user)).transaction_ro {|profdb|
        if profdb.key?("unappropriated-item")
          code = profdb["unappropriated-item"].to_i
          if !ac_titles.find_by_code(code)
            print "#{user}: unappro... #{code}\n"
            have_error = true
            ac_titles << AcTitle.new(code, code.to_s, "", 3, 1, "")
          end
        end
      }

      # 勘定科目を補正する
      if have_error
        AcTitleStore.store(user, ac_titles)
      end
    end
  }
end

if __FILE__ == $0
  main()
end
